/[gentoo-x86]/eclass/flag-o-matic.eclass
Gentoo

Diff of /eclass/flag-o-matic.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.40 Revision 1.147
1# Copyright 1999-2003 Gentoo Technologies, Inc. 1# Copyright 1999-2009 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/flag-o-matic.eclass,v 1.40 2004/03/12 11:21:15 vapier Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/flag-o-matic.eclass,v 1.147 2010/04/02 02:50:29 abcd Exp $
4
5# @ECLASS: flag-o-matic.eclass
6# @MAINTAINER:
7# toolchain@gentoo.org
8# @BLURB: common functions to manipulate and query toolchain flags
9# @DESCRIPTION:
10# This eclass contains a suite of functions to help developers sanely
11# and safely manage toolchain flags in their builds.
12
13inherit eutils toolchain-funcs multilib
14
15################ DEPRECATED functions ################
16# The following are still present to avoid breaking existing
17# code more than necessary; however they are deprecated. Please
18# use gcc-specs-* from toolchain-funcs.eclass instead, if you
19# need to know which hardened techs are active in the compiler.
20# See bug #100974
4# 21#
5# Author Bart Verwilst <verwilst@gentoo.org> 22# has_hardened
23# has_pie
24# has_pic
25# has_ssp_all
26# has_ssp
6 27
7ECLASS=flag-o-matic
8INHERITED="$INHERITED $ECLASS"
9 28
10#
11#### filter-flags <flags> ####
12# Remove particular flags from C[XX]FLAGS
13# Matches only complete flags
14#
15#### append-flags <flags> ####
16# Add extra flags to your current C[XX]FLAGS
17#
18#### replace-flags <orig.flag> <new.flag> ###
19# Replace a flag by another one
20#
21#### replace-cpu-flags <new.cpu> <old.cpus> ###
22# Replace march/mcpu flags that specify <old.cpus>
23# with flags that specify <new.cpu>
24#
25#### is-flag <flag> ####
26# Returns "true" if flag is set in C[XX]FLAGS
27# Matches only complete a flag
28#
29#### strip-flags ####
30# Strip C[XX]FLAGS of everything except known
31# good options.
32#
33#### strip-unsupported-flags ####
34# Strip C[XX]FLAGS of any flags not supported by
35# installed version of gcc
36#
37#### get-flag <flag> ####
38# Find and echo the value for a particular flag
39#
40#### replace-sparc64-flags ####
41# Sets mcpu to v8 and uses the original value
42# as mtune if none specified.
43#
44#### filter-mfpmath <math types> ####
45# Remove specified math types from the fpmath specification
46# If the user has -mfpmath=sse,386, running `filter-mfpmath sse`
47# will leave the user with -mfpmath=386
48#
49#### append-ldflags ####
50# Add extra flags to your current LDFLAGS
51#
52#### etexec-flags ####
53# hooked function for hardened-gcc that appends
54# -yet_exec {C,CXX,LD}FLAGS when hardened-gcc is installed
55# and a package is filtering -fPIC,-fpic, -fPIE, -fpie
56#
57#### fstack-flags ####
58# hooked function for hardened-gcc that appends
59# -yno_propolice to {C,CXX,LD}FLAGS when hardened-gcc is installed
60# and a package is filtering -fstack-protector, -fstack-protector-all
61#
62
63# C[XX]FLAGS that we allow in strip-flags 29# {C,CXX,F,FC}FLAGS that we allow in strip-flags
30# Note: shell globs and character lists are allowed
64setup-allowed-flags() { 31setup-allowed-flags() {
65 export ALLOWED_FLAGS="-O -O1 -O2 -mcpu -march -mtune -fstack-protector -pipe -g" 32 if [[ -z ${ALLOWED_FLAGS} ]] ; then
66 case "${ARCH}" in 33 export ALLOWED_FLAGS="-pipe"
67 mips) ALLOWED_FLAGS="${ALLOWED_FLAGS} -mips1 -mips2 -mips3 -mips4 -mabi" ;; 34 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -O -O0 -O1 -O2 -mcpu -march -mtune"
68 amd64) ALLOWED_FLAGS="${ALLOWED_FLAGS} -fPIC" ;; 35 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fstack-protector -fstack-protector-all"
36 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fbounds-checking -fno-strict-overflow"
37 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-PIE -fno-pie -fno-unit-at-a-time"
38 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -g -g[0-9] -ggdb -ggdb[0-9] -gstabs -gstabs+"
39 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-ident"
69 alpha) ALLOWED_FLAGS="${ALLOWED_FLAGS} -fPIC" ;; 40 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -W* -w"
70 ia64) ALLOWED_FLAGS="${ALLOWED_FLAGS} -fPIC" ;; 41 fi
71 esac 42 # allow a bunch of flags that negate features / control ABI
43 ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-stack-protector -fno-stack-protector-all \
44 -fno-strict-aliasing -fno-bounds-checking -fstrict-overflow -fno-omit-frame-pointer"
45 ALLOWED_FLAGS="${ALLOWED_FLAGS} -mregparm -mno-app-regs -mapp-regs \
46 -mno-mmx -mno-sse -mno-sse2 -mno-sse3 -mno-ssse3 -mno-sse4 -mno-sse4.1 \
47 -mno-sse4.2 -mno-avx -mno-aes -mno-pclmul -mno-sse4a -mno-3dnow \
48 -mno-popcnt -mno-abm \
49 -mips1 -mips2 -mips3 -mips4 -mips32 -mips64 -mips16 -mplt \
50 -msoft-float -mno-soft-float -mhard-float -mno-hard-float -mfpu \
51 -mieee -mieee-with-inexact -mschedule \
52 -mtls-direct-seg-refs -mno-tls-direct-seg-refs \
53 -mflat -mno-flat -mno-faster-structs -mfaster-structs \
54 -m32 -m64 -mabi -mlittle-endian -mbig-endian -EL -EB -fPIC \
55 -mlive-g0 -mcmodel -mstack-bias -mno-stack-bias \
56 -msecure-plt -m*-toc -D* -U*"
72 57
73 # C[XX]FLAGS that we are think is ok, but needs testing 58 # {C,CXX,F,FC}FLAGS that we are think is ok, but needs testing
74 # NOTE: currently -Os have issues with gcc3 and K6* arch's 59 # NOTE: currently -Os have issues with gcc3 and K6* arch's
75 export UNSTABLE_FLAGS="-Os -O3 -freorder-blocks -fprefetch-loop-arrays" 60 export UNSTABLE_FLAGS="-Os -O3 -freorder-blocks"
76 return 0 61 return 0
77} 62}
78 63
64# inverted filters for hardened compiler. This is trying to unpick
65# the hardened compiler defaults.
66_filter-hardened() {
67 local f
68 for f in "$@" ; do
69 case "${f}" in
70 # Ideally we should only concern ourselves with PIE flags,
71 # not -fPIC or -fpic, but too many places filter -fPIC without
72 # thinking about -fPIE.
73 -fPIC|-fpic|-fPIE|-fpie|-Wl,pie|-pie)
74 gcc-specs-pie || continue
75 is-flagq -nopie || append-flags -nopie;;
76 -fstack-protector)
77 gcc-specs-ssp || continue
78 is-flagq -fno-stack-protector || append-flags $(test-flags -fno-stack-protector);;
79 -fstack-protector-all)
80 gcc-specs-ssp-to-all || continue
81 is-flagq -fno-stack-protector-all || append-flags $(test-flags -fno-stack-protector-all);;
82 -fno-strict-overflow)
83 gcc-specs-nostrict || continue
84 is-flagq -fstrict-overflow || append-flags $(test-flags -fstrict-overflow);;
85 esac
86 done
87}
88
89# Remove occurrences of strings from variable given in $1
90# Strings removed are matched as globs, so for example
91# '-O*' would remove -O1, -O2 etc.
92_filter-var() {
93 local f x VAR VAL
94 declare -a new
95
96 VAR=$1
97 shift
98 eval VAL=\${${VAR}}
99 for f in ${VAL}; do
100 for x in "$@"; do
101 # Note this should work with globs like -O*
102 [[ ${f} == ${x} ]] && continue 2
103 done
104 eval new\[\${\#new\[@]}]=\${f}
105 done
106 eval export ${VAR}=\${new\[*]}
107}
108
109# @FUNCTION: filter-flags
110# @USAGE: <flags>
111# @DESCRIPTION:
112# Remove particular <flags> from {C,CPP,CXX,F,FC}FLAGS. Accepts shell globs.
79filter-flags() { 113filter-flags() {
80 for x in "$@" ; do 114 _filter-hardened "$@"
81 case "${x}" in 115 _filter-var CFLAGS "$@"
82 -fPIC|-fpic|-fPIE|-fpie|-pie) etexec-flags;; 116 _filter-var CPPFLAGS "$@"
83 -fstack-protector|-fstack-protector-all) fstack-flags;; 117 _filter-var CXXFLAGS "$@"
84 *) ;; 118 _filter-var FFLAGS "$@"
85 esac 119 _filter-var FCFLAGS "$@"
86 done
87
88 # we do this fancy spacing stuff so as to not filter
89 # out part of a flag ... we want flag atoms ! :D
90 CFLAGS=" ${CFLAGS} "
91 CXXFLAGS=" ${CXXFLAGS} "
92 for x in "$@" ; do
93 CFLAGS="${CFLAGS// ${x} / }"
94 CXXFLAGS="${CXXFLAGS// ${x} / }"
95 done
96 CFLAGS="${CFLAGS:1:${#CFLAGS}-2}"
97 CXXFLAGS="${CXXFLAGS:1:${#CXXFLAGS}-2}"
98 return 0 120 return 0
99} 121}
100 122
123# @FUNCTION: filter-lfs-flags
124# @DESCRIPTION:
125# Remove flags that enable Large File Support.
101filter-lfs-flags() { 126filter-lfs-flags() {
127 [[ -n $@ ]] && die "filter-lfs-flags takes no arguments"
102 filter-flags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE 128 filter-flags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE
103} 129}
104 130
131# @FUNCTION: append-cppflags
132# @USAGE: <flags>
133# @DESCRIPTION:
134# Add extra <flags> to the current CPPFLAGS.
135append-cppflags() {
136 [[ -z $* ]] && return 0
137 export CPPFLAGS="${CPPFLAGS} $*"
138 return 0
139}
140
141# @FUNCTION: append-cflags
142# @USAGE: <flags>
143# @DESCRIPTION:
144# Add extra <flags> to the current CFLAGS.
145append-cflags() {
146 [[ -z $* ]] && return 0
147 export CFLAGS="${CFLAGS} $*"
148 return 0
149}
150
151# @FUNCTION: append-cxxflags
152# @USAGE: <flags>
153# @DESCRIPTION:
154# Add extra <flags> to the current CXXFLAGS.
155append-cxxflags() {
156 [[ -z $* ]] && return 0
157 export CXXFLAGS="${CXXFLAGS} $*"
158 return 0
159}
160
161# @FUNCTION: append-fflags
162# @USAGE: <flags>
163# @DESCRIPTION:
164# Add extra <flags> to the current {F,FC}FLAGS.
165append-fflags() {
166 [[ -z $* ]] && return 0
167 export FFLAGS="${FFLAGS} $*"
168 export FCFLAGS="${FCFLAGS} $*"
169 return 0
170}
171
172# @FUNCTION: append-lfs-flags
173# @DESCRIPTION:
174# Add flags that enable Large File Support.
175append-lfs-flags() {
176 [[ -n $@ ]] && die "append-lfs-flags takes no arguments"
177 append-cppflags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE
178}
179
180# @FUNCTION: append-flags
181# @USAGE: <flags>
182# @DESCRIPTION:
183# Add extra <flags> to your current {C,CXX,F,FC}FLAGS.
105append-flags() { 184append-flags() {
106 export CFLAGS="${CFLAGS} $@" 185 [[ -z $* ]] && return 0
107 export CXXFLAGS="${CXXFLAGS} $@" 186 append-cflags "$@"
108 [ "`is-flag -fno-stack-protector`" -o "`is-flag -fno-stack-protector-all`" ] && fstack-flags 187 append-cxxflags "$@"
188 append-fflags "$@"
109 return 0 189 return 0
110} 190}
111 191
192# @FUNCTION: replace-flags
193# @USAGE: <old> <new>
194# @DESCRIPTION:
195# Replace the <old> flag with <new>. Accepts shell globs for <old>.
112replace-flags() { 196replace-flags() {
113 # we do this fancy spacing stuff so as to not filter 197 [[ $# != 2 ]] \
114 # out part of a flag ... we want flag atoms ! :D 198 && echo && eerror "Usage: replace-flags <old flag> <new flag>" \
115 CFLAGS=" ${CFLAGS} " 199 && die "replace-flags takes 2 arguments, not $#"
116 CXXFLAGS=" ${CXXFLAGS} "
117 CFLAGS="${CFLAGS// ${1} / ${2} }"
118 CXXFLAGS="${CXXFLAGS// ${1} / ${2} }"
119 CFLAGS="${CFLAGS:1:${#CFLAGS}-2}"
120 CXXFLAGS="${CXXFLAGS:1:${#CXXFLAGS}-2}"
121 return 0
122}
123 200
201 local f fset
202 declare -a new_CFLAGS new_CXXFLAGS new_FFLAGS new_FCFLAGS
203
204 for fset in CFLAGS CXXFLAGS FFLAGS FCFLAGS; do
205 # Looping over the flags instead of using a global
206 # substitution ensures that we're working with flag atoms.
207 # Otherwise globs like -O* have the potential to wipe out the
208 # list of flags.
209 for f in ${!fset}; do
210 # Note this should work with globs like -O*
211 [[ ${f} == ${1} ]] && f=${2}
212 eval new_${fset}\[\${\#new_${fset}\[@]}]=\${f}
213 done
214 eval export ${fset}=\${new_${fset}\[*]}
215 done
216
217 return 0
218}
219
220# @FUNCTION: replace-cpu-flags
221# @USAGE: <old> <new>
222# @DESCRIPTION:
223# Replace cpu flags (like -march/-mcpu/-mtune) that select the <old> cpu
224# with flags that select the <new> cpu. Accepts shell globs for <old>.
124replace-cpu-flags() { 225replace-cpu-flags() {
125 local newcpu="$1" ; shift 226 local newcpu="$#" ; newcpu="${!newcpu}"
126 local oldcpu="" 227 while [ $# -gt 1 ] ; do
127 for oldcpu in "$@" ; do 228 # quote to make sure that no globbing is done (particularly on
229 # ${oldcpu}) prior to calling replace-flags
128 replace-flags -march=${oldcpu} -march=${newcpu} 230 replace-flags "-march=${1}" "-march=${newcpu}"
129 replace-flags -mcpu=${oldcpu} -mcpu=${newcpu} 231 replace-flags "-mcpu=${1}" "-mcpu=${newcpu}"
130 replace-flags -mtune=${oldcpu} -mtune=${newcpu} 232 replace-flags "-mtune=${1}" "-mtune=${newcpu}"
233 shift
131 done 234 done
235 return 0
236}
237
238_is_flagq() {
239 local x
240 for x in ${!1} ; do
241 [[ ${x} == $2 ]] && return 0
242 done
132 return 0 243 return 1
133} 244}
134 245
246# @FUNCTION: is-flagq
247# @USAGE: <flag>
248# @DESCRIPTION:
249# Returns shell true if <flag> is in {C,CXX,F,FC}FLAGS, else returns shell false. Accepts shell globs.
250is-flagq() {
251 [[ -n $2 ]] && die "Usage: is-flag <flag>"
252 _is_flagq CFLAGS $1 || _is_flagq CXXFLAGS $1 || _is_flagq FFLAGS $1 || _is_flagq FCFLAGS $1
253}
254
255# @FUNCTION: is-flag
256# @USAGE: <flag>
257# @DESCRIPTION:
258# Echo's "true" if flag is set in {C,CXX,F,FC}FLAGS. Accepts shell globs.
135is-flag() { 259is-flag() {
136 for x in ${CFLAGS} ${CXXFLAGS} ; do 260 is-flagq "$@" && echo true
137 if [ "${x}" == "$1" ] ; then
138 echo true
139 return 0
140 fi
141 done
142 return 1
143} 261}
144 262
263# @FUNCTION: is-ldflagq
264# @USAGE: <flag>
265# @DESCRIPTION:
266# Returns shell true if <flag> is in LDFLAGS, else returns shell false. Accepts shell globs.
267is-ldflagq() {
268 [[ -n $2 ]] && die "Usage: is-ldflag <flag>"
269 _is_flagq LDFLAGS $1
270}
271
272# @FUNCTION: is-ldflag
273# @USAGE: <flag>
274# @DESCRIPTION:
275# Echo's "true" if flag is set in LDFLAGS. Accepts shell globs.
276is-ldflag() {
277 is-ldflagq "$@" && echo true
278}
279
280# @FUNCTION: filter-mfpmath
281# @USAGE: <math types>
282# @DESCRIPTION:
283# Remove specified math types from the fpmath flag. For example, if the user
284# has -mfpmath=sse,386, running `filter-mfpmath sse` will leave the user with
285# -mfpmath=386.
145filter-mfpmath() { 286filter-mfpmath() {
287 local orig_mfpmath new_math prune_math
288
146 # save the original -mfpmath flag 289 # save the original -mfpmath flag
147 local orig_mfpmath="`get-flag -mfpmath`" 290 orig_mfpmath=$(get-flag -mfpmath)
148 # get the value of the current -mfpmath flag 291 # get the value of the current -mfpmath flag
149 local new_math=" `get-flag mfpmath | tr , ' '` " 292 new_math=$(get-flag mfpmath)
293 new_math=" ${new_math//,/ } "
150 # figure out which math values are to be removed 294 # figure out which math values are to be removed
151 local prune_math="" 295 prune_math=""
152 for prune_math in "$@" ; do 296 for prune_math in "$@" ; do
153 new_math="${new_math/ ${prune_math} / }" 297 new_math=${new_math/ ${prune_math} / }
154 done 298 done
155 new_math="`echo ${new_math:1:${#new_math}-2} | tr ' ' ,`" 299 new_math=$(echo ${new_math})
300 new_math=${new_math// /,}
156 301
157 if [ -z "${new_math}" ] ; then 302 if [[ -z ${new_math} ]] ; then
158 # if we're removing all user specified math values are 303 # if we're removing all user specified math values are
159 # slated for removal, then we just filter the flag 304 # slated for removal, then we just filter the flag
160 filter-flags ${orig_mfpmath} 305 filter-flags ${orig_mfpmath}
161 else 306 else
162 # if we only want to filter some of the user specified 307 # if we only want to filter some of the user specified
164 replace-flags ${orig_mfpmath} -mfpmath=${new_math} 309 replace-flags ${orig_mfpmath} -mfpmath=${new_math}
165 fi 310 fi
166 return 0 311 return 0
167} 312}
168 313
314# @FUNCTION: strip-flags
315# @DESCRIPTION:
316# Strip C[XX]FLAGS of everything except known good/safe flags.
169strip-flags() { 317strip-flags() {
318 local x y flag NEW_CFLAGS NEW_CXXFLAGS NEW_FFLAGS NEW_FCFLAGS
319
170 setup-allowed-flags 320 setup-allowed-flags
171 321
172 local NEW_CFLAGS="" 322 local NEW_CFLAGS=""
173 local NEW_CXXFLAGS="" 323 local NEW_CXXFLAGS=""
324 local NEW_FFLAGS=""
325 local NEW_FCFLAGS=""
174 326
175 # Allow unstable C[XX]FLAGS if we are using unstable profile ... 327 # Allow unstable C[XX]FLAGS if we are using unstable profile ...
176 if [ `has ~${ARCH} ${ACCEPT_KEYWORDS}` ] ; then 328 if has "~$(tc-arch)" ${ACCEPT_KEYWORDS} ; then
177 [ `use debug` ] && einfo "Enabling the use of some unstable flags"
178 ALLOWED_FLAGS="${ALLOWED_FLAGS} ${UNSTABLE_FLAGS}" 329 ALLOWED_FLAGS="${ALLOWED_FLAGS} ${UNSTABLE_FLAGS}"
179 fi 330 fi
180 331
181 set -f 332 set -f # disable pathname expansion
182 333
183 for x in ${CFLAGS} 334 for x in ${CFLAGS}; do
184 do
185 for y in ${ALLOWED_FLAGS} 335 for y in ${ALLOWED_FLAGS}; do
186 do
187 flag=${x%%=*} 336 flag=${x%%=*}
188 if [ "${flag%%${y}}" = "" ] 337 if [ "${flag%%${y}}" = "" ] ; then
189 then
190 NEW_CFLAGS="${NEW_CFLAGS} ${x}" 338 NEW_CFLAGS="${NEW_CFLAGS} ${x}"
191 break 339 break
192 fi 340 fi
193 done 341 done
194 done 342 done
195 343
196 for x in ${CXXFLAGS} 344 for x in ${CXXFLAGS}; do
197 do
198 for y in ${ALLOWED_FLAGS} 345 for y in ${ALLOWED_FLAGS}; do
199 do
200 flag=${x%%=*} 346 flag=${x%%=*}
201 if [ "${flag%%${y}}" = "" ] 347 if [ "${flag%%${y}}" = "" ] ; then
202 then
203 NEW_CXXFLAGS="${NEW_CXXFLAGS} ${x}" 348 NEW_CXXFLAGS="${NEW_CXXFLAGS} ${x}"
204 break 349 break
205 fi 350 fi
206 done 351 done
207 done 352 done
208 353
354 for x in ${FFLAGS}; do
355 for y in ${ALLOWED_FLAGS}; do
356 flag=${x%%=*}
357 if [ "${flag%%${y}}" = "" ] ; then
358 NEW_FFLAGS="${NEW_FFLAGS} ${x}"
359 break
360 fi
361 done
362 done
363
364 for x in ${FCFLAGS}; do
365 for y in ${ALLOWED_FLAGS}; do
366 flag=${x%%=*}
367 if [ "${flag%%${y}}" = "" ] ; then
368 NEW_FCFLAGS="${NEW_FCFLAGS} ${x}"
369 break
370 fi
371 done
372 done
373
209 # In case we filtered out all optimization flags fallback to -O2 374 # In case we filtered out all optimization flags fallback to -O2
210 if [ "${CFLAGS/-O}" != "${CFLAGS}" -a "${NEW_CFLAGS/-O}" = "${NEW_CFLAGS}" ]; then 375 if [ "${CFLAGS/-O}" != "${CFLAGS}" -a "${NEW_CFLAGS/-O}" = "${NEW_CFLAGS}" ]; then
211 NEW_CFLAGS="${NEW_CFLAGS} -O2" 376 NEW_CFLAGS="${NEW_CFLAGS} -O2"
212 fi 377 fi
213 if [ "${CXXFLAGS/-O}" != "${CXXFLAGS}" -a "${NEW_CXXFLAGS/-O}" = "${NEW_CXXFLAGS}" ]; then 378 if [ "${CXXFLAGS/-O}" != "${CXXFLAGS}" -a "${NEW_CXXFLAGS/-O}" = "${NEW_CXXFLAGS}" ]; then
214 NEW_CXXFLAGS="${NEW_CXXFLAGS} -O2" 379 NEW_CXXFLAGS="${NEW_CXXFLAGS} -O2"
215 fi 380 fi
381 if [ "${FFLAGS/-O}" != "${FFLAGS}" -a "${NEW_FFLAGS/-O}" = "${NEW_FFLAGS}" ]; then
382 NEW_FFLAGS="${NEW_FFLAGS} -O2"
383 fi
384 if [ "${FCFLAGS/-O}" != "${FCFLAGS}" -a "${NEW_FCFLAGS/-O}" = "${NEW_FCFLAGS}" ]; then
385 NEW_FCFLAGS="${NEW_FCFLAGS} -O2"
386 fi
216 387
217 set +f 388 set +f # re-enable pathname expansion
218
219 [ `use debug` ] \
220 && einfo "CFLAGS=\"${NEW_CFLAGS}\"" \
221 && einfo "CXXFLAGS=\"${NEW_CXXFLAGS}\""
222 389
223 export CFLAGS="${NEW_CFLAGS}" 390 export CFLAGS="${NEW_CFLAGS}"
224 export CXXFLAGS="${NEW_CXXFLAGS}" 391 export CXXFLAGS="${NEW_CXXFLAGS}"
392 export FFLAGS="${NEW_FFLAGS}"
393 export FCFLAGS="${NEW_FCFLAGS}"
394 return 0
395}
396
397test-flag-PROG() {
398 local comp=$1
399 local flags="$2"
400
401 [[ -z ${comp} || -z ${flags} ]] && \
225 return 0 402 return 1
226}
227 403
404 local PROG=$(tc-get${comp})
405 ${PROG} ${flags} -S -o /dev/null -xc /dev/null \
406 > /dev/null 2>&1
407}
408
409# @FUNCTION: test-flag-CC
410# @USAGE: <flag>
411# @DESCRIPTION:
412# Returns shell true if <flag> is supported by the C compiler, else returns shell false.
413test-flag-CC() { test-flag-PROG "CC" "$1"; }
414
415# @FUNCTION: test-flag-CXX
416# @USAGE: <flag>
417# @DESCRIPTION:
418# Returns shell true if <flag> is supported by the C++ compiler, else returns shell false.
419test-flag-CXX() { test-flag-PROG "CXX" "$1"; }
420
421# @FUNCTION: test-flag-F77
422# @USAGE: <flag>
423# @DESCRIPTION:
424# Returns shell true if <flag> is supported by the Fortran 77 compiler, else returns shell false.
425test-flag-F77() { test-flag-PROG "F77" "$1"; }
426
427# @FUNCTION: test-flag-FC
428# @USAGE: <flag>
429# @DESCRIPTION:
430# Returns shell true if <flag> is supported by the Fortran 90 compiler, else returns shell false.
431test-flag-FC() { test-flag-PROG "FC" "$1"; }
432
433test-flags-PROG() {
434 local comp=$1
435 local flags
436 local x
437
438 shift
439
440 [[ -z ${comp} ]] && return 1
441
442 x=""
443 for x in "$@" ; do
444 test-flag-${comp} "${x}" && flags="${flags}${flags:+ }${x}"
445 done
446
447 echo "${flags}"
448
449 # Just bail if we dont have any flags
450 [[ -n ${flags} ]]
451}
452
453# @FUNCTION: test-flags-CC
454# @USAGE: <flags>
455# @DESCRIPTION:
456# Returns shell true if <flags> are supported by the C compiler, else returns shell false.
457test-flags-CC() { test-flags-PROG "CC" "$@"; }
458
459# @FUNCTION: test-flags-CXX
460# @USAGE: <flags>
461# @DESCRIPTION:
462# Returns shell true if <flags> are supported by the C++ compiler, else returns shell false.
463test-flags-CXX() { test-flags-PROG "CXX" "$@"; }
464
465# @FUNCTION: test-flags-F77
466# @USAGE: <flags>
467# @DESCRIPTION:
468# Returns shell true if <flags> are supported by the Fortran 77 compiler, else returns shell false.
469test-flags-F77() { test-flags-PROG "F77" "$@"; }
470
471# @FUNCTION: test-flags-FC
472# @USAGE: <flags>
473# @DESCRIPTION:
474# Returns shell true if <flags> are supported by the Fortran 90 compiler, else returns shell false.
475test-flags-FC() { test-flags-PROG "FC" "$@"; }
476
477# @FUNCTION: test-flags
478# @USAGE: <flags>
479# @DESCRIPTION:
480# Short-hand that should hopefully work for both C and C++ compiler, but
481# its really only present due to the append-flags() abomination.
482test-flags() { test-flags-CC "$@"; }
483
484# @FUNCTION: test_flag
485# @DESCRIPTION:
486# DEPRICIATED, use test-flags()
228test_flag() { 487test_flag() {
229 if gcc -S -xc "$@" -o /dev/null /dev/null >/dev/null 2>&1; then 488 ewarn "test_flag: deprecated, please use test-flags()!" >&2
230 echo "$@" 489
490 test-flags-CC "$@"
491}
492
493# @FUNCTION: test_version_info
494# @USAGE: <version>
495# @DESCRIPTION:
496# Returns shell true if the current C compiler version matches <version>, else returns shell false.
497# Accepts shell globs.
498test_version_info() {
499 if [[ $($(tc-getCC) --version 2>&1) == *$1* ]]; then
231 return 0 500 return 0
232 fi 501 else
233 return 1 502 return 1
503 fi
234} 504}
235 505
506# @FUNCTION: strip-unsupported-flags
507# @DESCRIPTION:
508# Strip {C,CXX,F,FC}FLAGS of any flags not supported by the active toolchain.
236strip-unsupported-flags() { 509strip-unsupported-flags() {
237 for x in ${CFLAGS} ; do 510 export CFLAGS=$(test-flags-CC ${CFLAGS})
238 NEW_CFLAGS=${NEW_CFLAGS}" ""`test_flag ${x}`" 511 export CXXFLAGS=$(test-flags-CXX ${CXXFLAGS})
239 done 512 export FFLAGS=$(test-flags-F77 ${FFLAGS})
240 for x in ${CXXFLAGS} ; do 513 export FCFLAGS=$(test-flags-FC ${FCFLAGS})
241 NEW_CXXFLAGS=${NEW_CXXFLAGS}" ""`test_flag ${x}`"
242 done
243
244 export CFLAGS="${NEW_CFLAGS}"
245 export CXXFLAGS="${NEW_CXXFLAGS}"
246} 514}
247 515
516# @FUNCTION: get-flag
517# @USAGE: <flag>
518# @DESCRIPTION:
519# Find and echo the value for a particular flag. Accepts shell globs.
248get-flag() { 520get-flag() {
521 local f findflag="$1"
522
249 # this code looks a little flaky but seems to work for 523 # this code looks a little flaky but seems to work for
250 # everything we want ... 524 # everything we want ...
251 # for example, if CFLAGS="-march=i686": 525 # for example, if CFLAGS="-march=i686":
252 # `get-flags -march` == "-march=i686" 526 # `get-flag -march` == "-march=i686"
253 # `get-flags march` == "i686" 527 # `get-flag march` == "i686"
254 local findflag="$1"
255 for f in ${CFLAGS} ${CXXFLAGS} ; do 528 for f in ${CFLAGS} ${CXXFLAGS} ${FFLAGS} ${FCFLAGS} ; do
256 if [ "${f/${findflag}}" != "${f}" ] ; then 529 if [ "${f/${findflag}}" != "${f}" ] ; then
257 echo "${f/-${findflag}=}" 530 printf "%s\n" "${f/-${findflag}=}"
258 return 0 531 return 0
259 fi 532 fi
260 done 533 done
261 return 1 534 return 1
262} 535}
263 536
537# @FUNCTION: has_hardened
538# @DESCRIPTION:
539# DEPRECATED - use gcc-specs-relro or gcc-specs-now from toolchain-funcs
540has_hardened() {
541 ewarn "has_hardened: deprecated, please use gcc-specs-{relro,now}()!" >&2
542
543 test_version_info Hardened && return 0
544 # The specs file wont exist unless gcc has GCC_SPECS support
545 [[ -f ${GCC_SPECS} && ${GCC_SPECS} != ${GCC_SPECS/hardened/} ]]
546}
547
548# @FUNCTION: has_pic
549# @DESCRIPTION:
550# DEPRECATED - use gcc-specs-pie from toolchain-funcs
551# indicate whether PIC is set
552has_pic() {
553 ewarn "has_pic: deprecated, please use gcc-specs-pie()!" >&2
554
555 [[ ${CFLAGS/-fPIC} != ${CFLAGS} || \
556 ${CFLAGS/-fpic} != ${CFLAGS} ]] || \
557 gcc-specs-pie
558}
559
560# @FUNCTION: has_pie
561# @DESCRIPTION:
562# DEPRECATED - use gcc-specs-pie from toolchain-funcs
563# indicate whether PIE is set
564has_pie() {
565 ewarn "has_pie: deprecated, please use gcc-specs-pie()!" >&2
566
567 [[ ${CFLAGS/-fPIE} != ${CFLAGS} || \
568 ${CFLAGS/-fpie} != ${CFLAGS} ]] || \
569 gcc-specs-pie
570}
571
572# @FUNCTION: has_ssp_all
573# @DESCRIPTION:
574# DEPRECATED - use gcc-specs-ssp from toolchain-funcs
575# indicate whether code for SSP is being generated for all functions
576has_ssp_all() {
577 ewarn "has_ssp_all: deprecated, please use gcc-specs-ssp()!" >&2
578
579 # note; this matches only -fstack-protector-all
580 [[ ${CFLAGS/-fstack-protector-all} != ${CFLAGS} || \
581 -n $(echo | $(tc-getCC) ${CFLAGS} -E -dM - | grep __SSP_ALL__) ]] || \
582 gcc-specs-ssp-to-all
583}
584
585# @FUNCTION: has_ssp
586# @DESCRIPTION:
587# DEPRECATED - use gcc-specs-ssp from toolchain-funcs
588# indicate whether code for SSP is being generated
589has_ssp() {
590 ewarn "has_ssp: deprecated, please use gcc-specs-ssp()!" >&2
591
592 # note; this matches both -fstack-protector and -fstack-protector-all
593 [[ ${CFLAGS/-fstack-protector} != ${CFLAGS} || \
594 -n $(echo | $(tc-getCC) ${CFLAGS} -E -dM - | grep __SSP__) ]] || \
595 gcc-specs-ssp
596}
597
598# @FUNCTION: has_m64
599# @DESCRIPTION:
600# This doesn't test if the flag is accepted, it tests if the flag actually
601# WORKS. Non-multilib gcc will take both -m32 and -m64. If the flag works
602# return code is 0, else the return code is 1.
603has_m64() {
604 # this doesnt test if the flag is accepted, it tests if the flag
605 # actually -WORKS-. non-multilib gcc will take both -m32 and -m64!
606 # please dont replace this function with test_flag in some future
607 # clean-up!
608
609 local temp="$(emktemp)"
610 echo "int main() { return(0); }" > "${temp}".c
611 MY_CC=$(tc-getCC)
612 ${MY_CC/ .*/} -m64 -o "$(emktemp)" "${temp}".c > /dev/null 2>&1
613 local ret=$?
614 rm -f "${temp}".c
615 [[ ${ret} != 1 ]] && return 0
616 return 1
617}
618
619# @FUNCTION: has_m32
620# @DESCRIPTION:
621# This doesn't test if the flag is accepted, it tests if the flag actually
622# WORKS. Non-mulilib gcc will take both -m32 and -64. If the flag works return
623# code is 0, else return code is 1.
624has_m32() {
625 # this doesnt test if the flag is accepted, it tests if the flag
626 # actually -WORKS-. non-multilib gcc will take both -m32 and -m64!
627 # please dont replace this function with test_flag in some future
628 # clean-up!
629
630 [ "$(tc-arch)" = "amd64" ] && has_multilib_profile && return 0
631
632 local temp=$(emktemp)
633 echo "int main() { return(0); }" > "${temp}".c
634 MY_CC=$(tc-getCC)
635 ${MY_CC/ .*/} -m32 -o "$(emktemp)" "${temp}".c > /dev/null 2>&1
636 local ret=$?
637 rm -f "${temp}".c
638 [[ ${ret} != 1 ]] && return 0
639 return 1
640}
641
642# @FUNCTION: replace-sparc64-flags
643# @DESCRIPTION:
644# Sets mcpu to v8 and uses the original value as mtune if none specified.
264replace-sparc64-flags() { 645replace-sparc64-flags() {
265 local SPARC64_CPUS="ultrasparc v9" 646 local SPARC64_CPUS="ultrasparc3 ultrasparc v9"
266 647
267 if [ "${CFLAGS/mtune}" != "${CFLAGS}" ] 648 if [ "${CFLAGS/mtune}" != "${CFLAGS}" ]; then
268 then
269 for x in ${SPARC64_CPUS} 649 for x in ${SPARC64_CPUS}; do
270 do
271 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8}" 650 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8}"
272 done 651 done
273 else 652 else
274 for x in ${SPARC64_CPUS} 653 for x in ${SPARC64_CPUS}; do
275 do
276 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}" 654 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}"
277 done 655 done
278 fi 656 fi
279 657
280 if [ "${CXXFLAGS/mtune}" != "${CXXFLAGS}" ] 658 if [ "${CXXFLAGS/mtune}" != "${CXXFLAGS}" ]; then
281 then
282 for x in ${SPARC64_CPUS} 659 for x in ${SPARC64_CPUS}; do
283 do
284 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8}" 660 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8}"
285 done 661 done
286 else 662 else
287 for x in ${SPARC64_CPUS} 663 for x in ${SPARC64_CPUS}; do
288 do
289 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}" 664 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}"
290 done 665 done
291 fi 666 fi
292}
293 667
668 export CFLAGS CXXFLAGS
669}
670
671# @FUNCTION: append-libs
672# @USAGE: <libs>
673# @DESCRIPTION:
674# Add extra <libs> to the current LIBS.
675append-libs() {
676 [[ -z $* ]] && return 0
677 local flag
678 for flag in "$@"; do
679 [[ ${flag} == -l* ]] && flag=${flag#-l}
680 export LIBS="${LIBS} -l${flag}"
681 done
682
683 return 0
684}
685
686# @FUNCTION: append-ldflags
687# @USAGE: <flags>
688# @DESCRIPTION:
689# Add extra <flags> to the current LDFLAGS.
294append-ldflags() { 690append-ldflags() {
691 [[ -z $* ]] && return 0
692 local flag
693 for flag in "$@"; do
694 [[ ${flag} == -l* ]] && \
695 ewarn "Appending a library link instruction (${flag}); libraries to link to should not be passed through LDFLAGS"
696 done
697
295 LDFLAGS="${LDFLAGS} $@" 698 export LDFLAGS="${LDFLAGS} $*"
296 return 0 699 return 0
297} 700}
298 701
299etexec-flags() { 702# @FUNCTION: filter-ldflags
300 has_version sys-devel/hardened-gcc 703# @USAGE: <flags>
301 if [ $? == 0 ] ; then 704# @DESCRIPTION:
302 if [ "`is-flag -yet_exec`" != "true" ]; then 705# Remove particular <flags> from LDFLAGS. Accepts shell globs.
303 debug-print ">>> appending flags -yet_exec" 706filter-ldflags() {
304 append-flags -yet_exec 707 _filter-var LDFLAGS "$@"
305 append-ldflags -yet_exec 708 return 0
306 fi
307 fi
308} 709}
309 710
310fstack-flags() { 711# @FUNCTION: raw-ldflags
311 has_version sys-devel/hardened-gcc 712# @USAGE: <flags>
312 if [ $? == 0 ] ; then 713# @DESCRIPTION:
313 if [ "`is-flag -yno_propolice`" != "true" ]; then 714# Turn C style ldflags (-Wl,-foo) into straight ldflags - the results
314 debug-print ">>> appending flags -yno_propolice" 715# are suitable for passing directly to 'ld'; note LDFLAGS is usually passed
315 append-flags -yno_propolice 716# to gcc where it needs the '-Wl,'.
316 append-ldflags -yno_propolice 717raw-ldflags() {
317 fi 718 local x input="$@"
318 fi 719 [[ -z ${input} ]] && input=${LDFLAGS}
720 set --
721 for x in ${input} ; do
722 x=${x#-Wl,}
723 set -- "$@" ${x//,/ }
724 done
725 echo "$@"
319} 726}
727
728# @FUNCTION: no-as-needed
729# @RETURN: Flag to disable asneeded behavior for use with append-ldflags.
730no-as-needed() {
731 case $($(tc-getLD) -v 2>&1 </dev/null) in
732 *GNU*) # GNU ld
733 echo "-Wl,--no-as-needed" ;;
734 esac
735}
736
737# Some tests for when we screw with things and want to make
738# sure we didn't break anything
739#TESTS() {
740# CFLAGS="-a -b -c=1"
741# CXXFLAGS="-x -y -z=2"
742# LDFLAGS="-l -m -n=3"
743#
744# die() { exit 1; }
745# (is-flag 1 2 3) && die
746# (is-ldflag 1 2 3) && die
747#
748# is-flagq -l && die
749# is-ldflagq -a && die
750# is-flagq -a || die
751# is-flagq -x || die
752# is-ldflagq -n=* || die
753# is-ldflagq -n && die
754#
755# strip-unsupported-flags
756# [[ ${CFLAGS} == "-c=1" ]] || die
757# [[ ${CXXFLAGS} == "-y -z=2" ]] || die
758#
759# echo "All tests pass"
760#}
761#TESTS

Legend:
Removed from v.1.40  
changed lines
  Added in v.1.147

  ViewVC Help
Powered by ViewVC 1.1.20